org.apache.lucene.collation

## Class CollationKeyFilter

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.TokenFilter
      - - org.apache.lucene.collation.CollationKeyFilter

All Implemented Interfaces:
  Closeable, AutoCloseable

Deprecated.
Use `CollationAttributeFactory` instead, which encodes terms directly as bytes. This filter will be removed in Lucene 5.0

    @Deprecated
    public final class CollationKeyFilter
    extends TokenFilter

Converts each token into its `CollationKey`, and then encodes the CollationKey with `IndexableBinaryStringTools`, to allow it to be stored as an index term.

WARNING: Make sure you use exactly the same Collator at index and query time -- CollationKeys are only comparable when produced by the same Collator. Since `RuleBasedCollator`s are not independently versioned, it is unsafe to search against stored CollationKeys unless the following are exactly the same (best practice is to store this information with the index and check that they remain the same at query time):

1. JVM vendor
2. JVM version, including patch version
3. The language (and country and variant, if specified) of the Locale used when constructing the collator via `Collator.getInstance(java.util.Locale)`.
4. The collation strength used - see `Collator.setStrength(int)`

The `ICUCollationKeyFilter` in the analysis-icu package uses ICU4J's Collator, which makes its version available, thus allowing collation to be versioned independently from the JVM. ICUCollationKeyFilter is also significantly faster and generates significantly shorter keys than CollationKeyFilter. See http://site.icu-project.org/charts/collation-icu4j-sun for key generation timing and key length comparisons between ICU4J and java.text.Collator over several languages.

CollationKeys generated by java.text.Collators are not compatible with those those generated by ICU Collators. Specifically, if you use CollationKeyFilter to generate index terms, do not use ICUCollationKeyFilter on the query side, or vice versa.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

`AttributeSource.AttributeFactory, AttributeSource.State`

### Field Summary

### Fields inherited from class org.apache.lucene.analysis.TokenFilter

`input`

### Constructor Summary

Constructors
Constructor and Description
`CollationKeyFilter(TokenStream input, Collator collator)` Deprecated.

### Method Summary

Methods
`boolean` `incrementToken()` Deprecated.

### Methods inherited from class org.apache.lucene.analysis.TokenFilter

`close, end, reset`

### Methods inherited from class org.apache.lucene.util.AttributeSource

`addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, restoreState`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CollationKeyFilter

    public CollationKeyFilter(TokenStream input,
                      Collator collator)

Deprecated.

Parameters:
  `input` - Source token stream
  `collator` - CollationKey generator

### Method Detail

#### incrementToken

    public boolean incrementToken()
                           throws IOException

Deprecated.

Specified by:
  `incrementToken` in class `TokenStream`
Throws:
  `IOException`